from OpenGL.GL import *

class Minimap(object):
	def __init__(self, level):
		self.level = level
	
	def compile(self):
		bb = self.level.shape.bbox()
		self.glist = glGenLists(1)
		glNewList(self.glist, GL_COMPILE)
		glPushAttrib(GL_ENABLE_BIT | GL_CURRENT_BIT)
		glDisable(GL_TEXTURE_2D)
		glBegin(GL_LINES)
		for seg in self.level.shape.segments:
			glVertex2f(seg.p1.x, seg.p1.y)
			glVertex2f(seg.p2.x, seg.p2.y)
		glEnd()

		glPointSize(5)
		glColor3f(1, 1, 1)
		glBegin(GL_POINTS)
		for ent in self.level.entities:
			glVertex2f(ent.loc.x, ent.loc.y)
		glEnd()

		glPopAttrib()
		glEndList()

	def render(self):
		glCallList(self.glist)

